#ifndef __VT_H__
#define __VT_H__

#include "FastFit.h"
#include "VcfRecord.h"
#include "VcfFileReader.h"
#include "VcfHeader.h"
#include "GroupFromAnnotation.h"

class VT
{
    public:
        VT();
        ~VT();
        static bool vcfAnnotated;
	
	static bool preProcess;
	static int chop;
	static String chopTo;
	static int permuteMin;
	static int permuteMax;
	static bool noStep;
	static bool asymptotic;
	static bool permuteBool;
	static bool VTwtMB;
	static bool VTwtCMC_binary;
	static bool VTwtCMC_counts;

        //this is the total number of genes
	int numVarPerGene;
	double markerMaf,mac;
	Vector mafIncluded,unique_maf;
	Matrix selectionIndicator;
	StringArray varsIncluded;
	StringIntHash  geneHash;
	StringArray geneChrom;
	std::vector<int> start,end;
	Matrix transGeno,tmpGenoMatrix;
	Vector singlevarPvalue,singlevarEff;

	Vector residuals_original,beta_hat,fixedEff;
	double sigma2_hat;
	int length;

	VcfFileReader reader;
	VcfHeader header;
	VcfRecord record;

	//void ChopAndWrite(Pedigree & ped,GroupFromAnnotation & group);

	//void PermuteTrait(Pedigree & ped, FastTransform & trans,int traitNum,int permutations);

	bool GetTmpGenoMatrixDosage(FastTransform & trans, Pedigree & ped,GroupFromAnnotation & group,int groupNum);
	bool GetTmpGenoMatrixVCF(FastTransform & trans, Pedigree & ped,GroupFromAnnotation & group,int groupNum);
	bool GetTmpGenoMatrixPED(FastTransform & trans, Pedigree & ped,GroupFromAnnotation & group,int groupNum);
	bool GetGenotypeMatrix(FastTransform & trans, Pedigree & ped,GroupFromAnnotation & group,int groupNum);
	bool FinalizeGenoMatrix(FastTransform & trans,bool reduceDimension);
	void CalculateAsymptotic(Pedigree & ped, FastTransform & trans,FastFit & engine,String & traitName,GroupFromAnnotation & group);
	void Run(Pedigree & ped, FastTransform & trans, FastFit & engine,String & traitName,GroupFromAnnotation & group);	

	double CalculatePvalue(Vector & score,Matrix & cov,double t_max);
	Vector GetConditionalDist(Vector & score,Matrix & cov,Vector & comb);
  void CalculateSingleVarPvalue(FastTransform & trans,String & geneName,FastFit & engine,Matrix & genotypeSKAT);
};

#endif
